"""file: sort.py

Implements heapsort, with a modular comparison function given as an
argument.

"""

def heap_at(li,p,comp):
  """makes li a heap at position p if it is already a heap at every
  descendant of p.

  """
  g,d,stop = 2*p,2*p+1,li[0]
  if g > stop: return None
  else:
    k = g if (d>stop or not comp(li[g],li[d])) else d
    if not comp(li[k],li[p]):
      li[k],li[p] = li[p],li[k]
      heap_at(li,k,comp)
    return None

def heapify(li,comp):
  """makes li a heap at every nodes : starting from the leaves and going
  upward with the help of heap_at.

  """
  stop = li[0]
  for p in range(stop/2,0,-1):
    heap_at(li,p,comp)
  return None 

def heapsort(li,comp):
  """returns a sorted copy of li by making it a heap and using heap sort

  """
  tmp = [len(li)] + li[:]
  heapify(tmp,comp)
  for n in range(len(tmp)-1,0,-1):
    tmp[n],tmp[1] = tmp[1],tmp[n]
    tmp[0] -= 1
    heap_at(tmp,1,comp)
  return tmp[1:]
